﻿using System;
using System.Collections;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Runtime.InteropServices;

namespace Nerv36
{
    public class Stub_information
    {
        // nerv_stub_information delegate
        public delegate Int32 on_link_ft(IntPtr _information_, Address _proxy_addr, Boolean _reliability, Double _elapsed, Double _limit);

        public delegate void on_unlink_ft(IntPtr _information_, Address _proxy_addr, Int32 _err);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_information_alloc")]
        public static extern IntPtr alloc(UInt16 _code, IntPtr _object, on_link_ft _on_link_, on_unlink_ft _on_unlink_);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_information_free")]
        public static extern void free(IntPtr _information_);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_information_set_sync_model")]
        public static extern void set_sync_model(Sync_model _sync_model, Double _interval);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_information_unlink")]
        public static extern void unlink(IntPtr _information_, Address _proxy_addr);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_information_unlink_all_proxy")]
        public static extern void unlink_all_proxy(IntPtr _information_);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_information_get")]
        public static extern IntPtr get(IntPtr _information_, UInt32 _inf_size);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_information_cancel")]
        public static extern void cancel(IntPtr _information_);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_information_post")]
        public static extern Int32 post(IntPtr _information_, UInt32 _inf_size);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_information_write")]
        public static extern Int32 write(IntPtr _information_, IntPtr _inf_dat_, UInt32 _inf_size);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_information_see_history")]
        public static extern IntPtr see_history(IntPtr _information_, UIntPtr _history_size);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_information_set_history_size")]
        public static extern void set_history_size(IntPtr _information_, UIntPtr _history_size);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_information_read")]
        public static extern Int32 read(IntPtr _information_, IntPtr _inf_dat_, ref UInt32 _inf_size_);
    }




}