<?xml version="1.0" encoding="UTF-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text" encoding="utf-8" indent="yes"/>



<xsl:template name ="template_call" >
  <xsl:variable name="in_data_domain_namespace">
    <xsl:call-template name="get_data_domain_namespace_dot">
      <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
    </xsl:call-template>
  </xsl:variable>
  <xsl:variable name="out_data_domain_namespace">
    <xsl:call-template name="get_data_domain_namespace_dot">
      <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
    </xsl:call-template>
  </xsl:variable>
// proxy
public interface IProxy_method_<xsl:value-of select="name"/>
{
    void on_return(UInt32 _msg_num, Int32 _err,<xsl:if test="out_data!='(null)'"> ref Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/> _ret_dat_,</xsl:if> Double _elapsed);
}
public unsafe class Proxy_method_<xsl:value-of select="name"/>
{
    static Nerv36.Proxy_call.on_return_ft on_return_ = new Nerv36.Proxy_call.on_return_ft(on_return);

    static ConcurrentDictionary&lt;IntPtr, Proxy_method_<xsl:value-of select="name"/>&gt; dict = new ConcurrentDictionary&lt;IntPtr, Proxy_method_<xsl:value-of select="name"/>&gt;();

    public static void on_return(IntPtr _call_, UInt32 _msg_num, Int32 _err, IntPtr _ret_dat_, UInt32 _ret_size, Double _elapsed)
    {<xsl:if test="out_data!='(null)'">
        Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>* ret_data_ = (Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>*)_ret_dat_;
        </xsl:if>
        dict[_call_].icall.on_return(_msg_num, _err,<xsl:if test="out_data!='(null)'"> ref *ret_data_,</xsl:if> _elapsed);
    }

    public IntPtr call_;
    public IProxy_method_<xsl:value-of select="name"/> icall;

    public Proxy_method_<xsl:value-of select="name"/>(ref Nerv36.Proxy _object_, IProxy_method_<xsl:value-of select="name"/> _icall)
    {
        call_ = Nerv36.Proxy_call.alloc(<xsl:value-of select="code"/>, _object_.object_, on_return_);
        dict[call_] = this;
        icall = _icall;
    }
    ~Proxy_method_<xsl:value-of select="name"/>()
    {
        // Nerv36.Proxy_call.free(call_);
        // API.nerv_finalize()에서 정리되지 않은 객체를 자동해제하므로
        // C#에서는 Nerv36.Proxy_call.free(call_); 로 정리하지 않는다.
        // C#의 소멸자는 언제 호출될지 알수 없다.

        Proxy_method_<xsl:value-of select="name"/> call;
        dict.TryRemove(call_, out call);
    }


    public Int32 delegate_call(ref UInt32 _msg_num_,<xsl:if test="in_data!='(null)'"> ref Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/> _cal_dat_,</xsl:if> Double _limit)
    {
        Int32 err;
        <xsl:if test="in_data!='(null)'">
        UInt32 cal_size = (UInt32)_cal_dat_.fit_size();
        fixed ( Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/>* cal_data_ = &amp;_cal_dat_)
        {
            err = Nerv36.Proxy_call.delegate_call( call_, ref _msg_num_, (IntPtr)cal_data_, cal_size, _limit);
        }
        </xsl:if>
        <xsl:if test="in_data='(null)'">
        err = Nerv36.Proxy_call.delegate_call( call_, ref _msg_num_, IntPtr.Zero, 0, _limit);
        </xsl:if>
        return err;
    }


    public IntPtr async_call(<xsl:if test="in_data!='(null)'">ref Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/> _cal_dat_,</xsl:if> Double _limit)
    {
        <xsl:if test="in_data!='(null)'">
        IntPtr promise_;
        UInt32 cal_size = (UInt32)_cal_dat_.fit_size();
        fixed ( Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/>* cal_data_ = &amp;_cal_dat_)
        {
            promise_ = Nerv36.Proxy_call.async_call( call_, (IntPtr)cal_data_, cal_size, _limit);
        }
        </xsl:if>
        <xsl:if test="in_data='(null)'">
        IntPtr promise_ = Nerv36.Proxy_call.async_call( call_, IntPtr.Zero, 0, _limit);
        </xsl:if>
        return promise_;
    }


    public Int32 await_return(IntPtr _promise_, <xsl:if test="out_data!='(null)'">ref Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/> _return_data_,</xsl:if> ref Double _elapsed_ )
    {
        <xsl:if test="out_data!='(null)'">
        UInt32 return_size = (UInt32)Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>._sizeof;
        fixed ( Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>* return_data_ = &amp;_return_data_)
        {
            Int32 err = Nerv36.Proxy_call.await_return(call_, _promise_, (IntPtr)return_data_, ref return_size, ref _elapsed_);
            return err;
        }
        </xsl:if>
        <xsl:if test="out_data='(null)'">
        UInt32 return_size = 0;
        Int32 err = Nerv36.Proxy_call.await_return(call_, _promise_, IntPtr.Zero, ref return_size, ref _elapsed_);
        return err;
        </xsl:if>
    }

    public Int32 call(<xsl:if test="in_data!='(null)'">ref Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/> _cal_dat_,</xsl:if>
                      <xsl:if test="out_data!='(null)'">ref Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/> _return_data_,</xsl:if>
                      Double _limit , ref Double _elapsed_ )
    {
        IntPtr promise_;
        <xsl:if test="in_data!='(null)'">
        UInt32 cal_size = (UInt32)_cal_dat_.fit_size();
        fixed ( Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/>* cal_data_ = &amp;_cal_dat_)
        {
            promise_ = Nerv36.Proxy_call.async_call( call_, (IntPtr)cal_data_, cal_size, _limit);
        }
        </xsl:if>
        <xsl:if test="in_data='(null)'">
        promise_ = Nerv36.Proxy_call.async_call( call_, IntPtr.Zero, 0, _limit);
        </xsl:if>
        <xsl:if test="out_data!='(null)'">
        UInt32 return_size = (UInt32)Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>._sizeof;
        fixed ( Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>* return_data_ = &amp;_return_data_)
        {
            Int32 err = Nerv36.Proxy_call.await_return(call_, promise_, (IntPtr)return_data_, ref return_size, ref _elapsed_);
            return err;
        }
        </xsl:if>
        <xsl:if test="out_data='(null)'">
        UInt32 return_size = 0;
        Int32 err = Nerv36.Proxy_call.await_return(call_, promise_, IntPtr.Zero, ref return_size, ref _elapsed_);
        return err;
        </xsl:if>

    }

    public void cancel(Int32 _err)
    {
        Nerv36.Proxy_call.cancel(call_, _err);
    }
}

// stub
public interface IStub_method_<xsl:value-of select="name"/>
{
    Int32 on_call( Address _proxy_addr, <xsl:if test="in_data!='(null)'">ref Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/> _cal_dat_,</xsl:if> <xsl:if test="out_data!='(null)'">ref Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/> _return_data_,</xsl:if> double _elapsed, double _limit);
    void on_cancel(Address _proxy_addr, Int32 _err);
}
public unsafe class Stub_method_<xsl:value-of select="name"/>
{
    static Nerv36.Stub_call.on_call_ft on_call_ = new Nerv36.Stub_call.on_call_ft(on_call);
    static Nerv36.Stub_call.on_cancel_ft on_cancel_ = new Nerv36.Stub_call.on_cancel_ft(on_cancel);
    static ConcurrentDictionary&lt;IntPtr, Stub_method_<xsl:value-of select="name"/>&gt; dict = new ConcurrentDictionary&lt;IntPtr, Stub_method_<xsl:value-of select="name"/>&gt;();

    public static Int32 on_call(IntPtr _call_,  Address _proxy_addr, IntPtr _cal_dat_, UInt32 _cal_size, IntPtr _return_data_, ref UInt32 _return_size,  double _elapsed, double _limit)
    {<xsl:if test="in_data!='(null)'">
        Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/>* cal_data_ = (Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/>*)_cal_dat_;
        </xsl:if>
        <xsl:if test="out_data!='(null)'">
        Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>* return_data_ = (Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>*)_return_data_;
        return_data_->init_dynamic_buffer(_return_size - Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>._sizeof);
        </xsl:if>
        return dict[_call_].icall.on_call(_proxy_addr,<xsl:if test="in_data!='(null)'"> ref *cal_data_,</xsl:if><xsl:if test="out_data!='(null)'"> ref *return_data_,</xsl:if> _elapsed, _limit);
    }
    public static void on_cancel(IntPtr _call_, Address _proxy_addr, Int32 _err)
    {
        dict[_call_].icall.on_cancel(_proxy_addr, _err);
    }

    public IntPtr call_;
    public IStub_method_<xsl:value-of select="name"/> icall;

    public Stub_method_<xsl:value-of select="name"/>(ref Nerv36.Stub _object_, IStub_method_<xsl:value-of select="name"/> _icall)
    {
        call_ = Nerv36.Stub_call.alloc(<xsl:value-of select="code"/>, <xsl:if test="out_data!='(null)'">Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>._sizeof + 10000000</xsl:if><xsl:if test="out_data='(null)'">0</xsl:if>, _object_.object_, on_call_, on_cancel_);
        dict[call_] = this;
        icall = _icall;
    }
    ~Stub_method_<xsl:value-of select="name"/>()
    {
        // Nerv36.Stub_call.free(call_);
        // API.nerv_finalize()에서 정리되지 않은 객체를 자동해제하므로
        // C#에서는 Nerv36.Stub_call.free(call_); 로 정리하지 않는다.
        // C#의 소멸자는 언제 호출될지 알수 없다.

        Stub_method_<xsl:value-of select="name"/> call;
        dict.TryRemove(call_, out call);
    }
}
</xsl:template>



</xsl:stylesheet>
