
#pragma once
/******************************************************************************
    domain   : Component
    domain creator   : root
    domain create date : 2021-12-20 19:06:49
    domain description :
    data name : Component_state
    data writer   : root
    data description:
*******************************************************************************/
#include <Nerv36/Data/Component/State.hh>
#include <Nerv36/Data/Component/State.hh>
#include <Nerv36/Data/Component/Error.hh>
#include <Nerv36/Nerv.hh>
#include <stdio.h>
#include <string>

namespace Nerv36 { namespace Data  { namespace Component {

#pragma pack(1)
#pragma warning(disable: 4200)
struct __attribute__((packed)) Component_state
{
// private:
//     Component_state() {}
//     ~Component_state() {}

public:
    /* 가변 데이터 버퍼 */

    ::Nerv36::Int64 __varray_offset; //

    ::Nerv36::Pksize sizeofall()
    {
        return (::Nerv36::Pksize)sizeof(*this) + (::Nerv36::Pksize)sizeof(::Nerv36::Pksize)*3 + dynamicmax();
    }

    void init_dynamic_buffer(size_t _size)
    {

        ::Nerv36::Int8* p = (::Nerv36::Int8*)&__varray_offset;

        ::Nerv36::Pksize* struct_offset_ = (::Nerv36::Pksize*)(p + sizeof(Component_state) + 0*sizeof(::Nerv36::Pksize));
        ::Nerv36::Pksize* dynamicmax_ = (::Nerv36::Pksize*)(p + sizeof(Component_state) + 1*sizeof(::Nerv36::Pksize));
        ::Nerv36::Pksize* dynamicsize_ = (::Nerv36::Pksize*)(p + sizeof(Component_state) + 2*sizeof(::Nerv36::Pksize));

        *struct_offset_ = sizeof(Component_state);
        *dynamicmax_ = (::Nerv36::Pksize)_size;
        *dynamicsize_ = 0;
        init_varray_offset( sizeof(Component_state) );
    }
    void init()
    {
        init_dynamic_buffer(dynamicmax());
    }
    static Component_state* malloc(size_t _size = 65536)
    {
        // 할당크기는 구조체 기본크기 + 가변버퍼 할당 제어 64bit index + 가변버퍼총크기
        void* buf_ = ::malloc( sizeof(Component_state) + 3*sizeof(::Nerv36::Pksize) +  _size );
        Component_state* new_ = (Component_state*)buf_;

        new_->init_dynamic_buffer(_size);

        return new_;
    }
    Component_state* realloc(size_t _size = 0)
    {
        if( _size <= dynamicmax() ) _size = dynamicmax()*2;
        void* buf_ = ::realloc( this, sizeof(Component_state) + 3*sizeof(::Nerv36::Pksize) +  _size );
        Component_state* new_ = (Component_state*)buf_;
        new_->dynamicmax() = (Pksize)_size;
        return new_;
    }

    void free() {
        ::free(this);
    }

    ::Nerv36::Pksize fit_size() const { return sizeof(Component_state) + 3*sizeof(::Nerv36::Pksize) + dynamicsize(); }

    void* memory()
    {
        return (void*)((uint8_t*)this + __varray_offset - struct_offset() );
    }

    const Pksize& struct_offset() const
    {
        return *(Pksize*)((uint8_t*)this + __varray_offset);
    }

    Pksize& struct_offset()
    {
        return *(Pksize*)((uint8_t*)this + __varray_offset);
    }

    Pksize& dynamicmax()
    {
        return *(Pksize*)((uint8_t*)this + __varray_offset + sizeof(::Nerv36::Pksize));
    }
    const Pksize& dynamicmax() const
    {
        return *(Pksize*)((uint8_t*)this + __varray_offset + sizeof(::Nerv36::Pksize));
    }
    Pksize& dynamicsize()
    {
        return *(Pksize*)((uint8_t*)this + __varray_offset + 2*sizeof(::Nerv36::Pksize));
    }
    const Pksize& dynamicsize() const
    {
        return *(Pksize*)((uint8_t*)this + __varray_offset + 2*sizeof(::Nerv36::Pksize));
    }
    ::Nerv36::uInt8* dynamicbuffer()
    {
        return ((uint8_t*)this + __varray_offset + 3*sizeof(Pksize));
    }
    const ::Nerv36::uInt8* dynamicbuffer() const
    {
        return ((const uint8_t*)this + __varray_offset + 3*sizeof(Pksize));
    }
    void init_varray_offset(::Nerv36::Int64 _varray_offset)
    {
        __varray_offset = _varray_offset;



    }


    //
    ::Nerv36::Data::Component::State cmd :9;

    //
    ::Nerv36::uInt32 emergency :1;

    //
    ::Nerv36::uInt32 release :1;

    //
    ::Nerv36::uInt32 reset :1;

    //
    ::Nerv36::Data::Component::State state :9;

    //
    ::Nerv36::uInt32 emergency_state :1;

    //
    ::Nerv36::uInt32 release_state :1;

    //
    ::Nerv36::uInt32 reset_state :1;

    //
    ::Nerv36::Data::Component::Error error :10;

    // 기본 상태값으로 확인하기 어려운
    // 나머지 모든 정보를 json 형식으로 전달받는다.
    Variable_array_field_dctrl json_dctrl;
    inline ::Nerv36::Char8 json_get_at(size_t _index) { return ((::Nerv36::Char8*)(dynamicbuffer()+json_dctrl.dindex))[_index]; }
    inline void json_set_at(size_t _index, ::Nerv36::Char8 _val) { ((::Nerv36::Char8*)(dynamicbuffer()+json_dctrl.dindex))[_index] = _val; }
    inline int json_maxsize() { return 0; }
    ::Nerv36::Char8* json() { return (::Nerv36::Char8*)(dynamicbuffer()+json_dctrl.dindex); }
    ::Nerv36::Char8 const* json() const { return (::Nerv36::Char8 const*)(dynamicbuffer()+json_dctrl.dindex); }
    size_t json_alloc(size_t _size)
    {
        size_t need_dynamics_size;
        const Pksize& dynamicmax_ = dynamicmax();
        Pksize& dynamicsize_ = dynamicsize();
        json_dctrl.dindex = dynamicsize_;
        size_t byte_size = _size*sizeof(::Nerv36::Char8);

        if(dynamicmax_ < dynamicsize_ + byte_size) {
            need_dynamics_size = dynamicsize_ + byte_size;
        }
        else {
            json_dctrl.dsize = (Pksize)byte_size;
            dynamicsize_ += json_dctrl.dsize;

            need_dynamics_size=0;
        }
        return need_dynamics_size;
    }
    int json_size() const
    {
        return json_dctrl.dsize / sizeof(::Nerv36::Char8);
    }



    void set(int _val)
    {

        cmd = (::Nerv36::Data::Component::State)_val;
        emergency = (::Nerv36::uInt32)_val;
        release = (::Nerv36::uInt32)_val;
        reset = (::Nerv36::uInt32)_val;
        state = (::Nerv36::Data::Component::State)_val;
        emergency_state = (::Nerv36::uInt32)_val;
        release_state = (::Nerv36::uInt32)_val;
        reset_state = (::Nerv36::uInt32)_val;
        error = (::Nerv36::Data::Component::Error)_val;
        json_alloc(1);
        json()[0] = (::Nerv36::Char8)_val;
    }

    void print(std::string _var)
    {

        printf( "sizeof(%s)=%d\n" , _var.c_str(), (int)sizeof(*this));
        printf( "%s.fit_size()=%d\n" , _var.c_str(), (int)fit_size());
        printf( "%s.cmd= %d\n" , _var.c_str(), (int)cmd);
        printf( "%s.emergency= %d\n" , _var.c_str(), (int)emergency);
        printf( "%s.release= %d\n" , _var.c_str(), (int)release);
        printf( "%s.reset= %d\n" , _var.c_str(), (int)reset);
        printf( "%s.state= %d\n" , _var.c_str(), (int)state);
        printf( "%s.emergency_state= %d\n" , _var.c_str(), (int)emergency_state);
        printf( "%s.release_state= %d\n" , _var.c_str(), (int)release_state);
        printf( "%s.reset_state= %d\n" , _var.c_str(), (int)reset_state);
        printf( "%s.error= %d\n" , _var.c_str(), (int)error);
        printf( "%s.json[0] =%d\n" , _var.c_str(), (int)json()[0]);
    }


};
#pragma warning(default : 4200)
#pragma pack()
typedef THistory_elem<Component_state> Component_state_history_elem;
typedef THistory<Component_state> Component_state_history;


} } /*  */ } /* Component */
