<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../../../xsl_util.xsl"/>
<xsl:output method="text" encoding="utf-8" indent="yes"/>

<!-- TODO : xalan 을 이용하는 배치파일을 만든다. 컴포넌트.xml + excute_xalan = 컴포넌트.bat = 헤더파일 + 소스파일 + cmake 파일 + 등등..... --><!-- xalan $xalan_out "c:\dev/ncgen.bat" $xalan_param save_path "'c:\dev'" "c:\dev\ai data.xml" "./xsl/excute_xalan.xsl" -->
<xsl:template match="/">
<xsl:variable name="component_name">
  <xsl:call-template name="replace">
    <xsl:with-param name="text" select="nerv_icde/component/name" />
    <xsl:with-param name="replace" select="' '" />
    <xsl:with-param name="by" select="'_'" />
  </xsl:call-template>
</xsl:variable>#!/bin/bash

# 빌드 바이너리 이름 지정 export OUTPUT="${PWD##*/}"
export OUTPUT="<xsl:value-of select="$component_name"/>"

# export B_CLEAN="clean"               # 빌드 디렉토리를 삭제
# export B_BUILD="build"               # 빌드 실행
# export B_RUN="run"                   # 빌드 결과물 실행
# export B_TYPE="shared library"       # 빌드시 공유 라이브러리 빌드
# export B_TYPE="static library"       # 빌드시 정적 라이브러리 빌드
export B_TYPE="excutable binary"       # 빌드시 실행파일 빌드
# export B_BUILD_TEST="build test"     # 라이브러리 빌드시 테스트 실행파일 빌드
export PARAMETER="hello"               # 빌드 결과물 실행시 전달할 파라미터
export DEBUG=1                         # if 1, 빌드시 디버그 정보를 포함하여 빌드
export TRACE=1                         # if > 1, 빌드시 TRACE 코드 반영하여 빌드
export ASSERT=1                        # if 1, 빌드시 ASSERT 코드 반영하여 빌드
export STDCXX="c++17"
export NINJA=0                         # 제너레이터에 닌자 사용(빠른 빌드)

</xsl:template>
</xsl:stylesheet>
