using System;
using System.Collections;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Runtime.InteropServices;

namespace Nerv36
{
    public class Proxy_callback
    {
        // nerv_proxy_callback delegate
        public delegate Int32 on_callback_ft(IntPtr _callback_, IntPtr _cal_dat_, UInt32 _cal_size, IntPtr _ret_dat_, ref UInt32 _ret_size_, Double _elapsed, Double _limit);

        public delegate void on_cancel_ft(IntPtr _callback_, Int32 _err);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_proxy_callback_alloc")]
        public static extern IntPtr alloc(UInt16 _code, UInt32 _max_return_size, IntPtr _object_, on_callback_ft _on_callback_, on_cancel_ft _on_cancel_);

        [DllImport("64nerv36.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_proxy_callback_free")]
        public static extern void free(IntPtr _callback_);
    }
}
