<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../../../../xsl_util.xsl"/>

<xsl:output method="text" encoding="utf-8" indent="yes"/>

<xsl:param name = "export_stub_class_id" />

<xsl:template match="/">
<xsl:variable name="component_name">
  <xsl:call-template name="replace">
    <xsl:with-param name="text" select="nerv_icde/component/name" />
    <xsl:with-param name="replace" select="' '" />
    <xsl:with-param name="by" select="'_'" />
  </xsl:call-template>
</xsl:variable>
  <xsl:for-each select="/nerv_icde/component/stub_list/row[id=$export_stub_class_id]">
    <xsl:variable name="interface_name" select="interface_name" />
    <xsl:variable name="class_name" select="class_name" />
#pragma once

#include "Exam_<xsl:value-of select="$component_name"/>/Nerv_stub/<xsl:value-of select="$class_name"/>_exam/<xsl:value-of select="$class_name"/>_exam.hh"

namespace <xsl:value-of select="$component_name"/> {
namespace Nerv_stub {

struct I<xsl:value-of select="$class_name"/>_ {
};


class <xsl:value-of select="$class_name"/> : public Exam::Nerv_stub::<xsl:value-of select="$class_name"/>_exam
{
    I<xsl:value-of select="$class_name"/>_* interface_;
public:
    <xsl:value-of select="$class_name"/>(I<xsl:value-of select="$class_name"/>_* _interface_ = 0);
    ~<xsl:value-of select="$class_name"/>();
};

} // namespace Nerv_stub
} // namespace <xsl:value-of select="$component_name"/>

  </xsl:for-each>
</xsl:template>

</xsl:stylesheet>
