<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../../../xsl_util.xsl"/>
<xsl:output method="text" encoding="utf-8" indent="yes"/>

<!-- TODO : xalan 을 이용하는 배치파일을 만든다. 컴포넌트.xml + excute_xalan = 컴포넌트.bat = 헤더파일 + 소스파일 + cmake 파일 + 등등..... --><!-- xalan $xalan_out "c:\dev/ncgen.bat" $xalan_param save_path "'c:\dev'" "c:\dev\ai data.xml" "./xsl/excute_xalan.xsl" -->
<xsl:template match="/">
<xsl:variable name="component_name">
  <xsl:call-template name="replace">
    <xsl:with-param name="text" select="nerv_icde/component/name" />
    <xsl:with-param name="replace" select="' '" />
    <xsl:with-param name="by" select="'_'" />
  </xsl:call-template>
</xsl:variable>#!/bin/bash
# Copyright 2021. Waregram Corp. all rights reserved.

# 빌드 바이너리 이름 지정 export OUTPUT="${PWD##*/}"
export OUTPUT="<xsl:value-of select="$component_name"/>"               # 빌드 바이너리 이름 지정

# export B_TYPE="shared library"         # 빌드시 공유 라이브러리 빌드
# export B_TYPE="static library"       # 빌드시 정적 라이브러리 빌드
export B_TYPE="excutable binary"        # 빌드시 실행파일 빌드
# export B_LIBRARY_TEST="library test"       # 라이브러리 빌드시 테스트 실행파일 빌드

export NINJA=1                         # 제너레이터에 닌자 사용(빠른 빌드)

declare -a PARAMETER                   # 빌드 결과물 실행시 전달할 파라미터
# PARAMETER[0]="bbb"
# PARAMETER[1]="aaa"
# PARAMETER[2]="is"


</xsl:template>
</xsl:stylesheet>
