
#pragma once
/******************************************************************************
    domain   : Image
    domain creator   : root
    domain create date : 2021-01-12 06:44:48
    domain description :
    data name : Image
    data writer   : root
    data description:
*******************************************************************************/
#include <Nerv36/Nerv.hh>
#include <stdio.h>
#include <string>

namespace Nerv36 { namespace Data  { namespace Image {

#pragma pack(1)
#pragma warning(disable: 4200)
struct __attribute__((packed)) Image
{
    Pksize __varray_offset;

    //
    Variable_array_field_dctrl field_1_dctrl;
    inline ::Nerv36::Char8 field_1_get_at(size_t index) { return ((::Nerv36::Char8*)(
        ( (uint8_t*)this - __varray_offset )

        +field_1_dctrl.dindex))[index]; }
    inline void field_1_set_at(size_t index, ::Nerv36::Char8 in_val) { ((::Nerv36::Char8*)(dynamicbuffer()+field_1_dctrl.dindex))[index] = in_val; }
    inline int field_1_maxsize() { return 10000000; }
    ::Nerv36::Char8* field_1() { return (::Nerv36::Char8*)(dynamicbuffer()+field_1_dctrl.dindex); }
    ::Nerv36::Char8 const* field_1() const { return (::Nerv36::Char8 const*)(dynamicbuffer()+field_1_dctrl.dindex); }
    bool field_1_alloc(int array_size)
    {
        bool ret_b;
        field_1_dctrl.dindex = dynamicsize();
        field_1_dctrl.dsize = array_size*sizeof(::Nerv36::Char8);
        if(_maxDynamicSize < dynamicsize() + field_1_dctrl.dsize) {
            ret_b=false;
        }
        else {
            dynamicsize() += field_1_dctrl.dsize;
            ret_b=true;
        }
        return ret_b;
    }
    int field_1_size() const
    {
        return field_1_dctrl.dsize / sizeof(::Nerv36::Char8);
    }


    /* 가변 데이터 버퍼 */
    enum {_maxDynamicSize=0+sizeof(::Nerv36::Char8)*10000000 };
    ::Nerv36::Pksize fit_size() const { return sizeof(Image)- _maxDynamicSize + dynamicsize(); }
    // ::Nerv36::Pksize dynamicsize;
    // ::Nerv36::uInt8 dynamicbuffer[_maxDynamicSize];  // dynamic buffer
    Pksize& dynamicsize()
    {
        return *(Pksize*)((uint8_t*)this + __varray_offset );
    }
    const Pksize& dynamicsize() const
    {
        return *(Pksize*)((uint8_t*)this + __varray_offset );
    }
    ::Nerv36::uInt8* dynamicbuffer()
    {
        return ((uint8_t*)this + __varray_offset + sizeof(Pksize));
    }
    const ::Nerv36::uInt8* dynamicbuffer() const
    {
        return ((const uint8_t*)this + __varray_offset + sizeof(Pksize));
    }

    void init_dynamic_buffer(Pksize _varray_offset = sizeof(Image))
    {
        __varray_offset = sizeof(Image);
        dynamicsize() = 0;

        {
            Pksize member_varray_offset = _varray_offset;
            member_varray_offset -= (uint8_t*)&member - (uint8_t*)this;
            member.init_dynamic_buffer( member_varray_offset );
        }
        {
            Pksize member_varray_offset = _varray_offset;
            member_varray_offset -= (uint8_t*)&member2 - (uint8_t*)this;
            member2.init_dynamic_buffer( member_varray_offset );
        }
    }
    // malloc 으로 동적버퍼를 가변적으로 잡을수 있어야 하므로
    // 생성자를 가지지 않아야 함.
    // 동적 버퍼에 크기 제한을 두지 않도록 변경됨.
    // Image(Pksize _varray_offset = sizeof(Image))
    // {
    //     __varray_offset = _varray_offset;
    //     init_dynamic_buffer();
    // }


    void set(int val)
    {

        init_dynamic_buffer();
        field_1_alloc(field_1_maxsize());
        field_1()[0] = (::Nerv36::Char8)val;
    }

    void print(std::string var)
    {

        printf( "sizeof(%s)=%d\n" , var.c_str(), (int)sizeof(*this));
        printf( "%s.fit_size()=%d\n" , var.c_str(), (int)fit_size());
        printf( "%s.field_1[0] =%d\n" , var.c_str(), (int)field_1()[0]);
    }
};
#pragma warning(default : 4200)
#pragma pack()
typedef THistory_elem<Image> Image_history_elem;
typedef THistory<Image> Image_history;


} } /*  */ } /* Image */
