<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../xsl_util.xsl"/>
<xsl:output method="text" encoding="utf-8" indent="yes"/>
<xsl:param name = "save_path" />
<xsl:param name = "xml_path" />
<!-- TODO : xalan 을 이용하는 배치파일을 만든다. 컴포넌트.xml + excute_xalan = 컴포넌트.bat = 헤더파일 + 소스파일 + cmake 파일 + 등등..... --><!-- xalan $xalan_out "c:\dev/ncgen.bat" $xalan_param save_path "'c:\dev'" "c:\dev\ai data.xml" "./xsl/excute_xalan.xsl" -->
<xsl:template match="/">
<xsl:variable name="component_name">
  <xsl:call-template name="replace">
    <xsl:with-param name="text" select="nerv_icde/component/name" />
    <xsl:with-param name="replace" select="' '" />
    <xsl:with-param name="by" select="'_'" />
  </xsl:call-template>
</xsl:variable>
<xsl:text/>#!/bin/bash
echo $0 $@

source /usr/local/share/Nerv/Nerv36/script_make/xalan_option

mkdir -p "<xsl:value-of select="$save_path"/>/export"
mkdir -p "<xsl:value-of select="$save_path"/>/import/Nerv36/include/Nerv36/Data/Component"
mkdir -p "<xsl:value-of select="$save_path"/>/import_exam"
mkdir -p "<xsl:value-of select="$save_path"/>/bin"
mkdir -p "<xsl:value-of select="$save_path"/>/src"
mkdir -p "<xsl:value-of select="$save_path"/>/@src"

cp -r "/usr/local/share/Nerv/Nerv36/include" "<xsl:value-of select="$save_path"/>/import/Nerv36/."
cp -r "/usr/local/share/Nerv/Nerv36/XSL/CXX/.vscode" "<xsl:value-of select="$save_path"/>/."
cp -r "/usr/local/share/Nerv/Nerv36/XSL/CXX/.vscode" "<xsl:value-of select="$save_path"/>/."
cp -r "/usr/local/share/Nerv/Nerv36/XSL/CXX/.script" "<xsl:value-of select="$save_path"/>/."
cp -r "/usr/local/share/Nerv/Nerv36/XSL/CXX/config" "<xsl:value-of select="$save_path"/>/."
cp -r "/usr/local/share/Nerv/Nerv36/XSL/CXX/import/Waregram" "<xsl:value-of select="$save_path"/>/import/."
cp -r "/usr/local/share/Nerv/Nerv36/XSL/CXX/import/Nerv36/include/Nerv36/Data/Component" "<xsl:value-of select="$save_path"/>/import/Nerv36/include/Nerv36/Data/."
cp    "/usr/local/share/Nerv/Nerv36/XSL/CXX/import/Nerv36/include/Nerv36/nerv_env.hh" "<xsl:value-of select="$save_path"/>/import/Nerv36/include/Nerv36/."
cp -r "/usr/local/share/Nerv/Nerv36/lib" "<xsl:value-of select="$save_path"/>/import/Nerv36/."
cp    "/usr/local/share/Nerv/Nerv36/XSL/CXX/source_list" "<xsl:value-of select="$save_path"/>/."
cp -rf  /usr/local/share/Nerv/Nerv36/lib/* "<xsl:value-of select="$save_path"/>/bin/."

cp    "/usr/local/share/Nerv/Nerv36/XSL/CXX/@src/user.hh" "<xsl:value-of select="$save_path"/>/@src/."
cp    "/usr/local/share/Nerv/Nerv36/XSL/CXX/import_exam/user.hh" "<xsl:value-of select="$save_path"/>/import_exam/."
cp    "/usr/local/share/Nerv/Nerv36/XSL/CXX/import_exam/examout.hh" "<xsl:value-of select="$save_path"/>/import_exam/."
cp    "/usr/local/share/Nerv/Nerv36/XSL/CXX/import_exam/examout.cc" "<xsl:value-of select="$save_path"/>/import_exam/."


rm "<xsl:value-of select="$save_path"/>/config/Common/option.xsl"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/config/Common/option" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/config/Common/option.xsl"<xsl:text/>
rm "<xsl:value-of select="$save_path"/>/.vscode/launch_json.xsl"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/.vscode/launch.json" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/.vscode/launch_json.xsl"<xsl:text/>


mkdir -p "<xsl:value-of select="$save_path"/>/import_exam/Exam_main_prompt"
mkdir -p "<xsl:value-of select="$save_path"/>/import_exam/@Exam_main_window"

<xsl:for-each select="nerv_icde/component/proxy_list/row">
mkdir -p "<xsl:value-of select="$save_path"/>/import_exam/Exam_<xsl:value-of select="$component_name"/>/Nerv_proxy/<xsl:value-of select="class_name"/>_exam"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/import_exam/Exam_<xsl:value-of select="$component_name"/>/Nerv_proxy/<xsl:value-of select="class_name"/>_exam/<xsl:value-of select="class_name"/>_exam.hh" $xalan_param export_proxy_class_id "'<xsl:value-of select="id"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/import_exam/Exam_component/Nerv_proxy/proxy_class_exam_hh.xsl"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/import_exam/Exam_<xsl:value-of select="$component_name"/>/Nerv_proxy/<xsl:value-of select="class_name"/>_exam/<xsl:value-of select="class_name"/>_exam.cc" $xalan_param export_proxy_class_id "'<xsl:value-of select="id"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/import_exam/Exam_component/Nerv_proxy/proxy_class_exam_cc.xsl"
</xsl:for-each>
<xsl:for-each select="nerv_icde/component/stub_list/row">
mkdir -p "<xsl:value-of select="$save_path"/>/import_exam/Exam_<xsl:value-of select="$component_name"/>/Nerv_stub/<xsl:value-of select="class_name"/>_exam"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/import_exam/Exam_<xsl:value-of select="$component_name"/>/Nerv_stub/<xsl:value-of select="class_name"/>_exam/<xsl:value-of select="class_name"/>_exam.hh" $xalan_param export_stub_class_id "'<xsl:value-of select="id"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/import_exam/Exam_component/Nerv_stub/stub_class_exam_hh.xsl"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/import_exam/Exam_<xsl:value-of select="$component_name"/>/Nerv_stub/<xsl:value-of select="class_name"/>_exam/<xsl:value-of select="class_name"/>_exam.cc" $xalan_param export_stub_class_id "'<xsl:value-of select="id"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/import_exam/Exam_component/Nerv_stub/stub_class_exam_cc.xsl"
</xsl:for-each>


xalan $xalan_out "<xsl:value-of select="$save_path"/>/import_exam/Exam_<xsl:value-of select="$component_name"/>/Exam_<xsl:value-of select="$component_name"/>.hh" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/import_exam/Exam_component/Exam_component_hh.xsl"<xsl:text/>
xalan $xalan_out "<xsl:value-of select="$save_path"/>/import_exam/Exam_<xsl:value-of select="$component_name"/>/Exam_<xsl:value-of select="$component_name"/>.cc" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/import_exam/Exam_component/Exam_component_cc.xsl"<xsl:text/>
xalan $xalan_out "<xsl:value-of select="$save_path"/>/import_exam/Exam_<xsl:value-of select="$component_name"/>/Exam_<xsl:value-of select="$component_name"/>_cmd.cc" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/import_exam/Exam_component/Exam_component_cmd_cc.xsl"<xsl:text/>
xalan $xalan_out "<xsl:value-of select="$save_path"/>/import_exam/Exam_<xsl:value-of select="$component_name"/>/Exam_<xsl:value-of select="$component_name"/>_on_state.cc" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/import_exam/Exam_component/Exam_component_on_state_cc.xsl"<xsl:text/>

xalan $xalan_out "<xsl:value-of select="$save_path"/>/import_exam/Exam_main_prompt/Exam_main_prompt.cc" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/import_exam/Exam_main_prompt/Exam_main_prompt_cc.xsl"<xsl:text/>
xalan $xalan_out "<xsl:value-of select="$save_path"/>/import_exam/Exam_main_prompt/Exam_main_prompt.hh" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/import_exam/Exam_main_prompt/Exam_main_prompt_hh.xsl"<xsl:text/>

xalan $xalan_out "<xsl:value-of select="$save_path"/>/import_exam/@Exam_main_window/Exam_main_window.ui" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/import_exam/@Exam_main_window/Exam_main_window_ui.xsl"<xsl:text/>
xalan $xalan_out "<xsl:value-of select="$save_path"/>/import_exam/@Exam_main_window/Exam_main_window.cpp" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/import_exam/@Exam_main_window/Exam_main_window_cpp.xsl"<xsl:text/>
xalan $xalan_out "<xsl:value-of select="$save_path"/>/import_exam/@Exam_main_window/Exam_main_window.hpp" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/import_exam/@Exam_main_window/Exam_main_window_hpp.xsl"<xsl:text/>

xalan $xalan_out "<xsl:value-of select="$save_path"/>/import_exam/exam.cc" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/import_exam/exam_cc.xsl"<xsl:text/>






mkdir -p "<xsl:value-of select="$save_path"/>/@src/Main_prompt"
mkdir -p "<xsl:value-of select="$save_path"/>/@src/Main_window"

<xsl:for-each select="nerv_icde/component/proxy_list/row">
mkdir -p "<xsl:value-of select="$save_path"/>/@src/The_<xsl:value-of select="$component_name"/>/Nerv_proxy/<xsl:value-of select="class_name"/>"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/@src/The_<xsl:value-of select="$component_name"/>/Nerv_proxy/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.hh" $xalan_param export_proxy_class_id "'<xsl:value-of select="id"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/@src/The_component/Nerv_proxy/proxy_class_hh.xsl"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/@src/The_<xsl:value-of select="$component_name"/>/Nerv_proxy/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.cc" $xalan_param export_proxy_class_id "'<xsl:value-of select="id"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/@src/The_component/Nerv_proxy/proxy_class_cc.xsl"
</xsl:for-each>
<xsl:for-each select="nerv_icde/component/stub_list/row">
mkdir -p "<xsl:value-of select="$save_path"/>/@src/The_<xsl:value-of select="$component_name"/>/Nerv_stub/<xsl:value-of select="class_name"/>"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/@src/The_<xsl:value-of select="$component_name"/>/Nerv_stub/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.hh" $xalan_param export_stub_class_id "'<xsl:value-of select="id"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/@src/The_component/Nerv_stub/stub_class_hh.xsl"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/@src/The_<xsl:value-of select="$component_name"/>/Nerv_stub/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.cc" $xalan_param export_stub_class_id "'<xsl:value-of select="id"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/@src/The_component/Nerv_stub/stub_class_cc.xsl"
</xsl:for-each>

xalan $xalan_out "<xsl:value-of select="$save_path"/>/@src/The_<xsl:value-of select="$component_name"/>/The_<xsl:value-of select="$component_name"/>.hh" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/@src/The_component/The_component_hh.xsl"<xsl:text/>
xalan $xalan_out "<xsl:value-of select="$save_path"/>/@src/The_<xsl:value-of select="$component_name"/>/The_<xsl:value-of select="$component_name"/>.cc" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/@src/The_component/The_component_cc.xsl"<xsl:text/>
xalan $xalan_out "<xsl:value-of select="$save_path"/>/@src/The_<xsl:value-of select="$component_name"/>/The_<xsl:value-of select="$component_name"/>_cmd.cc" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/@src/The_component/The_component_cmd_cc.xsl"<xsl:text/>
xalan $xalan_out "<xsl:value-of select="$save_path"/>/@src/The_<xsl:value-of select="$component_name"/>/The_<xsl:value-of select="$component_name"/>_on_state.cc" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/@src/The_component/The_component_on_state_cc.xsl"<xsl:text/>

xalan $xalan_out "<xsl:value-of select="$save_path"/>/@src/Main_prompt/Main_prompt.cc" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/@src/Main_prompt/Main_prompt_cc.xsl"<xsl:text/>
xalan $xalan_out "<xsl:value-of select="$save_path"/>/@src/Main_prompt/Main_prompt.hh" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/@src/Main_prompt/Main_prompt_hh.xsl"<xsl:text/>

xalan $xalan_out "<xsl:value-of select="$save_path"/>/@src/Main_window/Main_window.ui" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/@src/Main_window/Main_window_ui.xsl"<xsl:text/>
xalan $xalan_out "<xsl:value-of select="$save_path"/>/@src/Main_window/Main_window.cpp" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/@src/Main_window/Main_window_cpp.xsl"<xsl:text/>
xalan $xalan_out "<xsl:value-of select="$save_path"/>/@src/Main_window/Main_window.hpp" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/@src/Main_window/Main_window_hpp.xsl"<xsl:text/>

xalan $xalan_out "<xsl:value-of select="$save_path"/>/@src/<xsl:value-of select="$component_name"/>.cc" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/@src/component_cc.xsl"<xsl:text/>


xalan $xalan_out "<xsl:value-of select="$save_path"/>/src/main.cc" $xalan_param component_name "'<xsl:value-of select="$component_name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/src/main_cc.xsl"<xsl:text/>
















<xsl:for-each select="nerv_icde/datadomain/row">
mkdir -p "<xsl:value-of select="$save_path"/>/import/Nerv36/include/Nerv36/Data<xsl:value-of select="path"/>"<xsl:text/>
xalan $xalan_out "<xsl:value-of select="$save_path"/>/import/Nerv36/include/Nerv36/Data<xsl:value-of select="path"/>/<xsl:value-of select="name"/>.hh" $xalan_param export_data_domain_path "'<xsl:value-of select="path"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/import/Nerv36/include/Nerv36/Data/data_domain_hh.xsl"<xsl:text/>
  <xsl:variable name="path" select="path"/>
  <xsl:for-each select="data/row">
xalan $xalan_out "<xsl:value-of select="$save_path"/>/import/Nerv36/include/Nerv36/Data<xsl:value-of select="$path"/>/<xsl:value-of select="name"/>.hh" $xalan_param export_data_domain_path "'<xsl:value-of select="$path"/>'" $xalan_param export_data_name "'<xsl:value-of select="name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/import/Nerv36/include/Nerv36/Data/data_domain_data_hh.xsl"<xsl:text/>
  </xsl:for-each>
</xsl:for-each>
<xsl:for-each select="nerv_icde/methoddomain/row">
mkdir -p "<xsl:value-of select="$save_path"/>/import/Nerv36/include/Nerv36/Method<xsl:value-of select="path"/>"
  <xsl:variable name="path" select="path"/>
  <xsl:for-each select="method/row">
xalan $xalan_out "<xsl:value-of select="$save_path"/>/import/Nerv36/include/Nerv36/Method<xsl:value-of select="$path"/>/<xsl:value-of select="name"/>.hh" $xalan_param export_method_domain_path "'<xsl:value-of select="$path"/>'" $xalan_param export_method_name "'<xsl:value-of select="name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/import/Nerv36/include/Nerv36/Method/method_domain_method_hh.xsl"<xsl:text/>
  </xsl:for-each>
xalan $xalan_out "<xsl:value-of select="$save_path"/>/import/Nerv36/include/Nerv36/Method<xsl:value-of select="path"/>/<xsl:value-of select="name"/>.hh" $xalan_param export_method_domain_path "'<xsl:value-of select="path"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CXX/import/Nerv36/include/Nerv36/Method/method_domain_hh.xsl"<xsl:text/>
</xsl:for-each>
</xsl:template>
</xsl:stylesheet>
