<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="xml" encoding="utf-8" indent="yes"/>
<xsl:template name="chapter_1.1.3.3">
			<P InstId="" ParaShape="20" Style="3"><xsl:attribute name="InstId"><xsl:value-of select="generate-id()"/></xsl:attribute>
				<TEXT CharShape="8">
					<CHAR>사용자 인터페이스 식별</CHAR>
				</TEXT>
			</P>
			<P ParaShape="30" Style="9">
				<TEXT CharShape="13">
					<TABLE BorderFill="4" CellSpacing="0" ColCount="3" PageBreak="Cell" RepeatHeader="true" RowCount="">
					<xsl:attribute name="RowCount"><xsl:value-of select="count(/nerv_system_interface/system/nodes/node/processes/process/stubes/stub[public=1])*2+2"/></xsl:attribute>
						<SHAPEOBJECT InstId="" Lock="false" NumberingType="Table" ZOrder="12"><xsl:attribute name="InstId"><xsl:value-of select="generate-id()"/></xsl:attribute>
							<SIZE Height="22940" HeightRelTo="Absolute" Protect="false" Width="46492" WidthRelTo="Absolute"/>
							<POSITION AffectLSpacing="false" AllowOverlap="false" FlowWithText="true" HoldAnchorAndSO="false" HorzAlign="Left" HorzOffset="0" HorzRelTo="Para" TreatAsChar="false" VertAlign="Top" VertOffset="0" VertRelTo="Para"/>
							<OUTSIDEMARGIN Bottom="283" Left="283" Right="283" Top="283"/>
							<CAPTION FullSize="false" Gap="850" LastWidth="46492" Side="Top" Width="8504">
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Top">
									<P ParaShape="27" Style="0">
										<TEXT CharShape="2">
											<CHAR>표 </CHAR>
											<AUTONUM Number="2" NumberType="Table">
												<AUTONUMFORMAT Superscript="false" Type="Digit"/>
											</AUTONUM>
											<CHAR> 인터페이스 식별</CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CAPTION>
						</SHAPEOBJECT>
						<INSIDEMARGIN Bottom="567" Left="850" Right="850" Top="567"/>
						<ROW>
							<CELL BorderFill="9" ColAddr="0" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="true" Height="2134" Protect="false" RowAddr="0" RowSpan="2" Width="10000">
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="23">
										<TEXT CharShape="20">
											<CHAR>연동 식별자</CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
							<CELL BorderFill="9" ColAddr="1" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="true" Height="2134" Protect="false" RowAddr="0" RowSpan="1" Width="20000">
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="23">
										<TEXT CharShape="20">
											<CHAR>연동 대상 장비::</CHAR>
										</TEXT>
									</P>
									<P ParaShape="32" Style="23">
										<TEXT CharShape="20">
											<CHAR>연동 대상 CSC</CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
							<CELL BorderFill="9" ColAddr="2" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="true" Height="2134" Protect="false" RowAddr="0" RowSpan="2" Width="16492">
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="23">
										<TEXT CharShape="20">
											<CHAR>설계시 고려사항</CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
						</ROW>
						<ROW>
							<CELL BorderFill="9" ColAddr="1" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="true" Height="2134" Protect="false" RowAddr="1" RowSpan="1" Width="20000">
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="23">
										<TEXT CharShape="20">
											<CHAR>운영 Actor</CHAR>
										</TEXT>
									</P>
								</PARALIST>
							</CELL>
						</ROW>
<xsl:for-each select="/nerv_system_interface/system/nodes/node/processes/process/stubes/stub[public=1]">
<xsl:variable name="stub_name" select="name"/>
<xsl:variable name="stub_process" select="../../name"/>
<xsl:variable name="stub_node" select="../../../../name"/>
						<ROW>
							<CELL BorderFill="4" ColAddr="0" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="false" Height="1566" Protect="false" RowAddr="" RowSpan="2" Width="10000">
							<xsl:attribute name="RowAddr"><xsl:value-of select="position()*2"/></xsl:attribute>
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="24">
										<TEXT CharShape="21"><CHAR><xsl:value-of select="$stub_name"/></CHAR></TEXT>
									</P>
								</PARALIST>
							</CELL>
							<CELL BorderFill="4" ColAddr="1" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="false" Height="1566" Protect="false" RowAddr="" RowSpan="1" Width="20000">
							<xsl:attribute name="RowAddr"><xsl:value-of select="position()*2"/></xsl:attribute>
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="24">
										<TEXT CharShape="21"><CHAR><xsl:value-of select="$stub_node"/>::</CHAR></TEXT>
									</P>
									<P ParaShape="32" Style="24">
										<TEXT CharShape="21"><CHAR><xsl:value-of select="$stub_process"/></CHAR></TEXT>
									</P>
								</PARALIST>
							</CELL>
							<CELL BorderFill="4" ColAddr="2" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="false" Height="1566" Protect="false" RowAddr="" RowSpan="2" Width="16492">
							<xsl:attribute name="RowAddr"><xsl:value-of select="position()*2"/></xsl:attribute>
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
									<P ParaShape="32" Style="24">
										<TEXT CharShape="21"><CHAR>Stub으로 인터페이스를 제공한다.</CHAR></TEXT>
									</P>
								</PARALIST>
							</CELL>
						</ROW>
						<ROW>
							<CELL BorderFill="4" ColAddr="1" ColSpan="1" Dirty="false" Editable="false" HasMargin="false" Header="false" Height="1566" Protect="false" RowAddr="" RowSpan="1" Width="20000">
							<xsl:attribute name="RowAddr"><xsl:value-of select="position()*2+1"/></xsl:attribute>
								<CELLMARGIN Bottom="141" Left="510" Right="510" Top="141"/>
								<PARALIST LineWrap="Break" LinkListID="0" LinkListIDNext="0" TextDirection="0" VertAlign="Center">
<xsl:if test="count(/nerv_system_interface/system/nodes/node/processes/process/proxies/proxy[name=$stub_name]) = 0">
									<P/>
</xsl:if>
<xsl:for-each select="/nerv_system_interface/system/nodes/node/processes/process/proxies/proxy[name=$stub_name]">
<xsl:variable name="proxy_name" select="name"/>
<xsl:variable name="proxy_process" select="../../name"/>
<xsl:variable name="proxy_node" select="../../../../name"/>
									<P ParaShape="32" Style="24">
										<TEXT CharShape="21"><CHAR><xsl:value-of select="$proxy_node"/>::</CHAR></TEXT>
									</P>
									<P ParaShape="32" Style="24">
										<TEXT CharShape="21"><CHAR><xsl:value-of select="$proxy_process"/></CHAR></TEXT>
									</P>
									<P/>
</xsl:for-each>
								</PARALIST>
							</CELL>
						</ROW>
</xsl:for-each>
					</TABLE>
					<CHAR/>
				</TEXT>
			</P>
			<P/>
</xsl:template>
</xsl:stylesheet>